// TextUtil.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "AcExtensionModule.h"

#include "TextUtil.h"
#include "AVBUtilAcad.h"
#include <aced.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

AC_IMPLEMENT_EXTENSION_MODULE(theArxDLL);
/****************************************************************************
**
**    CString modchr(CString text)
**
**    **avb
**
*************************************/
CString modchr(CString text)
{
CString s;
int n=text.GetLength();
int nu=0;
int ash,L,R,c;
CString znach,a,b,znn,nzn,zn;
if (n>0){//0

	while (nu < n)
	{//1
		znn=text.Mid(nu,n);
		
		ash=*(char*)((const char*)znn);
		
		s.Format("%i",ash);
		switch (ash) {//2
		case 92:
			znach=znn.Mid(3,4);
			a=znach.Mid(2,1);
			b=znach.Right(1);
				if		(a=="A") L=10;
				else if (a=="B") L=11;
				else if (a=="C") L=12;
				else if (a=="D") L=13;
				else if (a=="E") L=14;
				else if (a=="F") L=15;
				else	L=atoi(a);
				if		(b=="A") R=10;
				else if (b=="B") R=11;
				else if (b=="C") R=12;
				else if (b=="D") R=13;
				else if (b=="E") R=14;
				else if (b=="F") R=15;
				else	R=atoi(b);
				c = L * 16 + R;
				nzn.Format("%c",c);
				nu = nu + 6;

			break;
		 default:
			nzn.Format("%c",ash);
			break;

		}//2
		    nu = nu + 1;
            zn = zn + nzn;
			
	}//1

}//0



return zn;
}
/****************************************************************************
**
**    int modchr_attrib(AcDbObjectId attId)
**
**    **avb
**
*************************************/

int modchr_attrib(AcDbObjectId objId)
{
AcDbEntity* pEnt=NULL;
AcDbText* pText;
CString text;


		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if  (pEnt->isKindOf(AcDbText::desc()))
		{
		pText = AcDbText::cast(pEnt);
		text=pText->textString();
		pText->setTextString(modchr(text));
		pEnt->close();
		}
		


return 0;
}
/****************************************************************************
**
**    void modchr_chBlock(blokName)
**
**    **avb
**
*************************************/
void modchr_chBlock(CString blokName)
{
	AcDbText* pText;
	AcDbMText* pMText;
	AcDbText* psText;
	
	AcDbBlockReference* pBlRef;
	AcDbObjectId styleId,attId,entId;
	AcDbEntity* psEnt=NULL;
	AcDbEntity *pEnt;
	//CAVBTextUtil tu;
	//ads_name ent;
	//AcGePoint3d pt;
	CString text;
	AcDbBlockTable *pBlockTable;
	acdbHostApplicationServices()->workingDatabase()
	->getSymbolTable(pBlockTable, AcDb::kForRead);
	AcDbBlockTableRecord *pBlockTableRecord;
	pBlockTable->getAt(blokName, pBlockTableRecord,AcDb::kForWrite);
	pBlockTable->close();
	AcDbBlockTableRecordIterator *pBlockIterator;
	
	pBlockTableRecord->newIterator(pBlockIterator);

		for (; !pBlockIterator->done();pBlockIterator->step())
		{//1
		
			pBlockIterator->getEntity(pEnt, AcDb::kForWrite);
			AcDbHandle objHandle;
			pEnt->getAcDbHandle(objHandle);
			char handleStr[20];
			objHandle.getIntoAsciiBuffer(handleStr);
			const char *pCname = pEnt->isA()->name();
			CString str;
			str.Format("%s",pCname);
			
			if (str=="AcDbBlockReference")
			{//2
				
			pBlRef = AcDbBlockReference::cast(pEnt);

			AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
			
			if (pIterator != NULL) {//3
			
				while (pIterator->done() == false) 
				{//4
				attId=pIterator->objectId();
				acdbOpenObject(psEnt, attId, AcDb::kForWrite);
				if (psEnt->isKindOf(AcDbText::desc()))
				{//5
					psText = AcDbText::cast(psEnt);
					text=psText->textString();
					psText->setTextString(modchr(text));
					psEnt->close();
				}//5
				pIterator->step();
				}//4
				delete pIterator;
			
			}//3
			
			}//2
			else if ((str=="AcDbText")||(str=="AcDbAttributeDefinition"))
			{//2
				pText = AcDbText::cast(pEnt);
				text=pText->textString();
				pText->setTextString(modchr(text));
			}//2
			else if (pEnt->isKindOf(AcDbMText::desc()))
			{//2
				pMText = AcDbMText::cast(pEnt);
				text=pMText->contents();
				pMText->setContents(modchr(text));
				pEnt->close();			
		
				
			}//2
			pEnt->close();
					
		}//1
	
		delete pBlockIterator;
		pBlockTableRecord->close();
}

/****************************************************************************
**
**    int modchr_ent(AcDbObjectId objId)
**
**    **avb
**
*************************************/

int modchr_ent(AcDbObjectId objId)
{
AcDbEntity* pEnt=NULL;
AcDbText* pText;
AcDbAttributeDefinition* pAtDef;
AcDbMText* pMText;
AcDbDimension* pDim;
CString text;


		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if  (pEnt->isKindOf(AcDbText::desc()))
		{
		pText = AcDbText::cast(pEnt);
		if (pEnt->isKindOf( AcDbAttributeDefinition::desc()))
		{
			pAtDef = AcDbAttributeDefinition::cast(pEnt);
			text=pAtDef->tag();
			pAtDef->setTag(modchr(text));
			pEnt->close();
		}
		else
		{
		text=pText->textString();
		pText->setTextString(modchr(text));
		pEnt->close();
		}
		}
		else if (pEnt->isKindOf(AcDbMText::desc()))
		{
		pMText = AcDbMText::cast(pEnt);
		text=pMText->contents();
		pMText->setContents(modchr(text));
		pEnt->close();
		}
		else if (pEnt->isKindOf(AcDbDimension::desc()))
		{
		pDim = AcDbDimension::cast(pEnt);
		text=pDim->dimensionText();
		pDim->setDimensionText(modchr(text));
		pEnt->close();
		}

return 0;
}
/****************************************************************************
**
**    int modchr_blref(AcDbObjectId objId)
**
**    **avb
**
*************************************/

int modchr_blref(AcDbObjectId objId)
{
AcDbObjectId attId;
AcDbEntity* pEnt=NULL;
AcDbText* psText;
AcDbEntity* psEnt=NULL;
AcDbBlockReference* pBlRef;
CString text;
bool blresbuf=FALSE;
acdbOpenObject(pEnt, objId, AcDb::kForWrite);
	
if (pEnt->isKindOf(AcDbBlockReference::desc()))
		{//1
	
		pBlRef = AcDbBlockReference::cast(pEnt);

		AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
			if (pIterator != NULL) {//2
				
				while (pIterator->done() == false) 
				{//3
				attId=pIterator->objectId();
				acdbOpenObject(psEnt, attId, AcDb::kForWrite);
				
					if (psEnt->isKindOf(AcDbText::desc()))
					{//4
					psText = AcDbText::cast(psEnt);
					text=psText->textString();
					
					psText->setTextString(modchr(text));
					
					psEnt->close();
					
					}//4
				pIterator->step();
				}//3
				
				delete pIterator;
			
				
				
				refresh();
				
			}//2
		
		}//1

pEnt->close();
return 0;
}
/****************************************************************************
**
**    ansi1252_1251()
**
**    **avb
**
*************************************/
void ansi1252_1251()
{

ads_name sset; 
AcDbObjectId objId;
AcDbEntity* pEnt=NULL;
bool blresbuf=FALSE;
long length;

if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1

acedSSLength(sset, &length);
  for (int i = 0; i < length; i++)
	{//2
      
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);

	  if  (
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))||
		  (pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//3
				pEnt->close();
				
				int res=modchr_ent(objId);
				if (res==1)
				{
					acedCommand(RTSTR, _T("Regen"),0); 
					return;
				}

			
			}//3
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
		  {
			pEnt->close();
			acdbGetAdsName(ent,objId); 
			struct resbuf *entdata;
			entdata = acdbEntGet(ent); 
			int iresbuf=getLength(entdata);
			if (iresbuf==22)
			{
				
				CString blokName;
				blokName =getBlockName(entdata);
				modchr_chBlock(blokName);
				blresbuf=TRUE;
				
			}
			else
			modchr_blref(objId);
			acutRelRb(entdata);
		
		}
	  else 
		  pEnt->close();


	 }//2
}//1
if(blresbuf==TRUE)
	acedCommand(RTSTR, _T("Regen"),0); 
}
/****************************************************************************
**
**    move
**
**    **avb
**
*************************************/

void moveString(AcDbObjectId objId,ads_point prBasePt,
				ads_point prToPt)
{
    AcDbEntity* pEnt;
	acdbOpenObject(pEnt, objId, AcDb::kForRead);
	AcGeMatrix3d xform;
    AcGeVector3d transVec,vecBasePt,vecprToPt;
	       	vecBasePt.set(prBasePt[X],prBasePt[Y],prBasePt[Z]);
			vecprToPt.set(prToPt[X],prToPt[Y],prToPt[Z]);
			transVec=vecprToPt-vecBasePt;
    
    xform.setToTranslation(transVec);
	
    doXform(pEnt, xform);
	
    pEnt->close();
}

/******************************************************************
**  void copy_String()
**
**	 
**
**  **avb
**
****************************/
void copy_String()
{
bool blcount=FALSE;
ads_name sset; 
AcDbObjectId objId,attId;
AcDbEntity* pEnt=NULL;
AcDbEntity* psEnt=NULL;
AcDbText* psText;
AcDbBlockReference* pBlRef=NULL;
long length;
ads_point pt1,pt2;
//AcDbObject *pObj;
AcDbObjectIdArray  objList;
AcDbObjectId ownerId = AcDbObjectId::kNull;

if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1
	
	int result;
acedSSLength(sset, &length);

  for (int i = 0; i < length; i++)
	{//2
      
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);
	  //const char *pCname = pEnt->isA()->name();
	  //acutPrintf(pCname);

	  if  (//3
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))//||
		  //(pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//4
				pEnt->highlight();
				//pEnt->erase();	
				pEnt->close();
				blcount=TRUE;
				
			}//4
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
				{//3
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) {//4
						while (pIterator->done() == false) 
						{//5
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
						if (psEnt->isKindOf(AcDbText::desc()))
						{//6
							psText = AcDbText::cast(psEnt);
							
							pEnt->highlight();
							psEnt->close();
							pEnt->close();
							blcount=TRUE;
							
			
						}//6
						pIterator->step();
						}//5
					delete pIterator;
					pEnt->close();
					refresh();
					}//4

				}//3
	  else 
	  
		  pEnt->close();
		  

	 }//2
  if (blcount==FALSE) return;
  	result=acedGetPoint(NULL,"\n  :",pt1);
	if (result == RTCAN) 
		return ;
	if (result == RTERROR )
		return ;

  	result=acedGetPoint(pt1,"\n :",pt2);
	if (result == RTCAN) 
		return ;
	if (result == RTERROR )
		return ;
	AcGePoint3d pt(pt2[X], pt2[Y],pt2[Z]);
	for (i = 0; i < length; i++)
	{//2
      ads_name ent;
	  acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForRead);
	  if  (
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))//||
		  //(pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//3
			
				pEnt->close();
				cloneObjects(objId);
				moveString(objId,pt1,pt2);

  			
			}//3
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
				{//3
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) {//4
						while (pIterator->done() == false) 
						{//5
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
						if (psEnt->isKindOf(AcDbText::desc()))
						{//6
							psText = AcDbText::cast(psEnt);
							
							psEnt->unhighlight();
							//psEnt->copy();
							psEnt->close();
							pEnt->close();
							cloneObjects(objId);
							moveString(attId,pt1,pt2);
							
			
						}//6
						pIterator->step();
						}//5
					delete pIterator;
					pEnt->close();
					refresh();
					}//4

				}//3
	  else 
	  
		  pEnt->close();
		  

	 }//2

}//1

}
/******************************************************************
**  void move_String()
**
**	 
**
**  **avb
**
****************************/
void move_String()
{
bool blcount=FALSE;
ads_name sset; 
AcDbObjectId objId,attId;
AcDbEntity* pEnt=NULL;
AcDbEntity* psEnt=NULL;
AcDbText* psText;
AcDbBlockReference* pBlRef=NULL;
long length;
ads_point pt1,pt2;
AcDbObjectIdArray  objList;
AcDbObjectId ownerId = AcDbObjectId::kNull;

if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1
	
	int result;
acedSSLength(sset, &length);

  for (int i = 0; i < length; i++)
	{//2
      
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);

	  if  (//3
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))//||
		  //(pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//4
		  
				pEnt->highlight();
				//pEnt->erase();	
				pEnt->close();
				blcount=TRUE;
				
			}//4
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
				{//3
		  
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) {//4
						while (pIterator->done() == false) 
						{//5
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
						if (psEnt->isKindOf(AcDbText::desc()))
						{//6
							psText = AcDbText::cast(psEnt);
							
							pEnt->highlight();
							psEnt->close();
							pEnt->close();
							blcount=TRUE;
							
			
						}//6
						pIterator->step();
						}//5
					delete pIterator;
					pEnt->close();
					refresh();
					}//4

				}//3
	  else 
	  
		  pEnt->close();
		  

	 }//2
  if (blcount==FALSE) return;
  	result=acedGetPoint(NULL,"\n  :",pt1);
	if (result == RTCAN) 
		return ;
	if (result == RTERROR )
		return ;

  	result=acedGetPoint(pt1,"\n :",pt2);
	if (result == RTCAN) 
		return ;
	if (result == RTERROR )
		return ;
	AcGePoint3d pt(pt2[X], pt2[Y],pt2[Z]);
	for (i = 0; i < length; i++)
	{//2
      ads_name ent;
	  acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForRead);
	  if  (
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))//||
		  //(pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//3
			
				pEnt->close();
				moveString(objId,pt1,pt2);

  			
			}//3
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
				{//3
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) {//4
						while (pIterator->done() == false) 
						{//5
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
						if (psEnt->isKindOf(AcDbText::desc()))
						{//6
							psText = AcDbText::cast(psEnt);
							
							psEnt->unhighlight();
							//psEnt->copy();
							psEnt->close();
							pEnt->close();
							moveString(attId,pt1,pt2);
							
			
						}//6
						pIterator->step();
						}//5
					delete pIterator;
					pEnt->close();
					refresh();
					}//4

				}//3
	  else 
	  
		  pEnt->close();
		  

	 }//2

}//1

}
/******************************************************************
**  void transfAtAtDef()
**
**	 ATDEF  ATTRIB  TEXT
**
**  **avb
**
****************************/
void transfAtAtDef()
{
ads_name sset; 
AcDbObjectId objId,styleId,attId;
AcDbEntity* pEnt=NULL;
AcDbEntity* psEnt=NULL;
AcGePoint3d pt;
//AcDbText* pText;
AcDbText* psText;
AcDbAttributeDefinition* pAtDef;
//AcDbMText* pMText;
AcDbBlockReference* pBlRef;
//AcDbDimension* pDText;
int n;
long length;
if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1

acedSSLength(sset, &length);
  for (int i = 0; i < length; i++)
	{//2
 
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		int result=100;
		const char *pCname = pEnt->isA()->name();
			CString str;
			str.Format("%s",pCname);
		if (str=="AcDbAttributeDefinition")
		{
		
			pAtDef=AcDbAttributeDefinition::cast(pEnt) ;
			// ATTDEF  TEXT
			CString tag =pAtDef->tag();
			AcDbObjectId idObj;
			AcDbObjectId styleId=pAtDef->textStyle(); ;
			double height = pAtDef->height();
			double rotation = pAtDef->rotation();
			AcDbText *pnText = new AcDbText(pAtDef->position() ,tag,styleId,height,rotation);
			pnText->setWidthFactor(pAtDef->widthFactor());
			pnText->setOblique(pAtDef->oblique());
			pnText->setHorizontalMode(pAtDef->horizontalMode());
			pnText->setAlignmentPoint(pAtDef->alignmentPoint());
			pnText->setPosition(pAtDef->position());
			pnText->setTextStyle(styleId);
			postToDatabase(pnText, idObj);
			pEnt->erase();
			pEnt->close();
			pnText->close();
			n++;
			
			
		}//3
		
		else if (pEnt->isKindOf(AcDbBlockReference::desc()))
		{//3
			
			
			pBlRef = AcDbBlockReference::cast(pEnt);
			//MessageBox(NULL,"privet","",NULL);
			AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
			
			if (pIterator != NULL) {//4
			
				while (pIterator->done() == false) 
				{//5
				attId=pIterator->objectId();
				acdbOpenObject(psEnt, attId, AcDb::kForWrite);
				if (psEnt->isKindOf(AcDbText::desc()))
				{//6
					
					psText = AcDbText::cast(psEnt);
					styleId=psText->textStyle(); 
					// ATTRIB  TEXT
					CString text =psText->textString();
					AcDbObjectId idObj;
					AcDbObjectId styleId=psText->textStyle(); ;
					double height = psText->height();
					double rotation = psText->rotation();
					AcDbText *pnText = new AcDbText(psText->position() ,text,styleId,height,rotation);
					pnText->setWidthFactor(psText->widthFactor());
					pnText->setOblique(psText->oblique());
					pnText->setHorizontalMode(psText->horizontalMode());
					pnText->setAlignmentPoint(psText->alignmentPoint());
					pnText->setPosition(psText->position());
					pnText->setTextStyle(styleId);
					postToDatabase(pnText, idObj);
					psEnt->erase();
					psEnt->close();
					pnText->close();
					n++;
					
				}//6
				pIterator->step();
				}//5
			delete pIterator;
			pEnt->close();
			
			
			
			
			}//4
		}//3*/
		else

			pEnt->close();


	
	}//2

/// 
acedSSFree(sset);
acedCommand(RTSTR, _T("_regen"), 0); 
CString sn, stn;
sn.Format("%i",n);
stn="\n   - " +sn;
acutPrintf(stn);
}//1


}
/******************************************************************
**  void delString()
**
**	 
**
**  **avb
**
****************************/
void delString()
{
ads_name sset; 
AcDbObjectId objId,attId;
AcDbEntity* pEnt=NULL;
AcDbEntity* psEnt=NULL;
AcDbText* psText;
AcDbBlockReference* pBlRef=NULL;
long length;
if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1

acedSSLength(sset, &length);
  for (int i = 0; i < length; i++)
	{//2
      
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);
	  //const char *pCname = pEnt->isA()->name();
	  //acutPrintf(pCname);

	  if  (//3
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))//||
		  //(pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//4
				pEnt->erase();	
				pEnt->close();
				
			}//4
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
				{//3
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) {//4
						while (pIterator->done() == false) 
						{//5
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
						if (psEnt->isKindOf(AcDbText::desc()))
						{//6
							psText = AcDbText::cast(psEnt);
							
							psEnt->erase();
							psEnt->close();
							pEnt->close();
							
			
						}//6
						pIterator->step();
						}//5
					delete pIterator;
					pEnt->close();
					refresh();
					}//4

				}//3
	  else 
	  
		  pEnt->close();
		  

	 }//2
}//1
}
/******************************************************************
**  void startCommand_1()
**
**	
**
**  **avb
**
****************************/
void startCommand_1()
{
	chDlg dlg(CWnd::FromHandle(adsw_acadMainWnd()));
    int nReturnValue = dlg.DoModal();
}
/******************************************************************
**  void startCommand_2()
**
**	
**
**  **avb
**
****************************/
void startCommand_2()
{
	dwDlg dlg(CWnd::FromHandle(adsw_acadMainWnd()));
    int nReturnValue = dlg.DoModal();
}
/******************************************************************
**  void startCommand_3()
**
**	
**
**  **avb
**
****************************/
void startCommand_3()
{
	transfAtAtDef();

}
/******************************************************************
**  void startCommand_4()
**
**	
**
**  **avb
**
****************************/
void startCommand_4()
{
	delString();
}

/******************************************************************
**  void startCommand_6()
**
**	
**
**  **avb
**
****************************/
void startCommand_6()
{
	replDlg dlg(CWnd::FromHandle(adsw_acadMainWnd()));
    int nReturnValue = dlg.DoModal();
}
/******************************************************************
**  void startCommand_7()
**
**	
**
**  **avb
**
****************************/
void startCommand_7()
{
	avbAbout dlg(CWnd::FromHandle(adsw_acadMainWnd()));
    int nReturnValue = dlg.DoModal();
}
/******************************************************************
**  void startCommand_8()
**
**	
**
**  **avb
**
****************************/
void startCommand_8()
{
	move_String();
	
}
/******************************************************************
**  void startCommand_9()
**
**	
**
**  **avb
**
****************************/
void startCommand_9()
{
	copy_String();
	
}
/******************************************************************
**  void startCommand_10()
**
**	
**
**  **avb
**
****************************/
void startCommand_10()
{
	ansi1252_1251();
	
}
/******************************************************************
**  void initApp()
**
**	
**
**  **avb
**
****************************/
static void initApp(void* appId)
{
AfxInitRichEdit();
acedRegCmds->addCommand("TextUtil","Command1","chText",ACRX_CMD_MODAL,startCommand_1);
acedRegCmds->addCommand("TextUtil","Command2","dwText",ACRX_CMD_MODAL,startCommand_2);
acedRegCmds->addCommand("TextUtil","Command3","expText",ACRX_CMD_MODAL,startCommand_3);
acedRegCmds->addCommand("TextUtil","Command4","delText",ACRX_CMD_MODAL,startCommand_4);
acedRegCmds->addCommand("TextUtil","Command6","replText",ACRX_CMD_MODAL,startCommand_6);
acedRegCmds->addCommand("TextUtil","Command7","aboutText",ACRX_CMD_MODAL,startCommand_7);
acedRegCmds->addCommand("TextUtil","Command8","moveText",ACRX_CMD_MODAL,startCommand_8);
acedRegCmds->addCommand("TextUtil","Command9","copyText",ACRX_CMD_MODAL,startCommand_9);
acedRegCmds->addCommand("TextUtil","Command10","ansiText",ACRX_CMD_MODAL,startCommand_10);

}
/******************************************************************
**  static void unloadApp()
**
**	 
**
**  **avb
**
****************************/
static void unloadApp()
{
 acedRegCmds->removeGroup("TextUtil");

}
/******************************************************************
**
**
**	 
**
**  **avb
**
****************************/

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
    // Remove this if you use lpReserved
    UNREFERENCED_PARAMETER(lpReserved);

    if (dwReason == DLL_PROCESS_ATTACH)
    {
        theArxDLL.AttachInstance(hInstance);
    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
        theArxDLL.DetachInstance();
    }
    return 1;   // ok
}


extern "C" AcRx::AppRetCode acrxEntryPoint( AcRx::AppMsgCode msg, void* appId)
{
    switch( msg )
    {
    case AcRx::kInitAppMsg:
        acrxDynamicLinker->unlockApplication(appId);
        acrxDynamicLinker->registerAppMDIAware(appId);
        initApp(appId);
		
        break;
    case AcRx::kUnloadAppMsg:
        unloadApp();
		

        break;
    case AcRx::kInitDialogMsg:

        break;
    default:
        break;
    }
    return AcRx::kRetOK;
}