// avbAbout.cpp : implementation file
//

#include "stdafx.h"
#include "avbAbout.h"
#include <acedads.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// avbAbout dialog


avbAbout::avbAbout(CWnd* pParent /*=NULL*/)
	: CAcUiDialog(avbAbout::IDD, pParent)
{
	//{{AFX_DATA_INIT(avbAbout)
	//}}AFX_DATA_INIT
}

avbAbout::~avbAbout()
{
	if ((HFONT)m_fontLogo)
		m_fontLogo.DeleteObject();
	if ((HFONT)m_fontName)
		m_fontName.DeleteObject();
	if ((HFONT)m_fontYear)
		m_fontYear.DeleteObject();

}

void avbAbout::DoDataExchange(CDataExchange* pDX)
{
	CAcUiDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(avbAbout)
	DDX_Control(pDX, IDC_HYPERLINK_MAIL, m_HyperLinkMail);
	DDX_Control(pDX, IDC_RICHEDIT, m_richedit_info);
	DDX_Control(pDX, IDC_HYPERLINK_SAIT, m_HyperLinkSait);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(avbAbout, CAcUiDialog)
	//{{AFX_MSG_MAP(avbAbout)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// avbAbout message handlers

BOOL avbAbout::OnInitDialog() 
{
	CDialog::OnInitDialog();

	
	SetNameFont("Verdana");

	m_HyperLinkMail.SetURL(_T("mailto:avbsoft@kulichki.com"));
	m_HyperLinkMail.SetUnderline(FALSE);
	m_HyperLinkMail.SetLinkCursor(AfxGetApp()->LoadCursor(IDC_HAND));
	m_HyperLinkMail.SetColours(RGB(128,128,128),RGB(85, 26, 139));

	

	m_HyperLinkSait.SetURL(_T("http://avbsoft.kulichki.net"));
	m_HyperLinkSait.SetUnderline(FALSE);
	m_HyperLinkSait.SetLinkCursor(AfxGetApp()->LoadCursor(IDC_HAND));
	m_HyperLinkSait.SetColours(RGB(128,128,128),RGB(85, 26, 139));



	m_richedit_info.SetRTF(regRTF());

	
	return TRUE; 

}



void avbAbout::OnPaint() 
{
    CPaintDC dc(this); // device context for painting

    CRect rectDlg;
    GetWindowRect(rectDlg);
    ScreenToClient(rectDlg);
    CFont* OldFont = dc.SelectObject(&m_fontLogo);

    CSize sizeText = dc.GetTextExtent(STLOGO, strlen(STLOGO));

    dc.DrawState(CPoint((rectDlg.Width()-sizeText.cx)/2, 5), 
                 rectDlg.Size(), 
                 STLOGO, 
                 DSS_DISABLED, TRUE, 0, (CBrush*)NULL);

    dc.SelectObject(OldFont);

	///////////////////////////////////////
	CFont* OldFontName = dc.SelectObject(&m_fontName);

    CSize sizeTextName = dc.GetTextExtent(STNAME, strlen(STNAME));

    dc.DrawState(CPoint(3*(rectDlg.Width()-sizeTextName.cx)/4, 25), 
                 rectDlg.Size(), 
                 STNAME, 
                 DSS_DISABLED, TRUE, 0, (CBrush*)NULL);

    dc.SelectObject(OldFontName);
	///////////////////////////////////////

    CFont* OldFontYear = dc.SelectObject(&m_fontYear);

    CSize sizeTextYear = dc.GetTextExtent(STYEAR, strlen(STYEAR));

    dc.DrawState(CPoint(9*(rectDlg.Width()-sizeTextYear.cx)/10, 45), 
                 rectDlg.Size(), 
                 STYEAR, 
                 DSS_DISABLED, TRUE, 0, (CBrush*)NULL);

    dc.SelectObject(OldFontYear);


}
void avbAbout::SetNameFont(CString Name, int nHeight, int nWeight, BYTE bItalic, BYTE bUnderline)
{
  if(m_fontName.m_hObject) m_fontName.Detach();

  m_fontName.CreateFont(nHeight, 0, 0, 0, nWeight, bItalic, bUnderline,0,204,0,0,0,0, Name);
} // End of SetLogoFont

CString avbAbout::regRTF()
{
CString str;
str="{\\rtf1\\ansi\\deflang1033{\\fonttbl{\\f37\\fnil\\fcharset0\\fprq0 Arial;}{\\f385\\fnil\\fcharset0\\fprq0 Times New Roman;}{\\f422\\fswiss\\fcharset204\\fprq2 Arial Cyr;}{\\f426\\froman\\fcharset204\\fprq2 Times New Roman Cyr;}}{\\colortbl;\\red0\\green0\\blue0;\\red0\\green0\\blue255;\\red0\\green255\\blue255;\\red0\\green255\\blue0;\\red255\\green0\\blue255;\\red255\\green0\\blue0;\\red255\\green255\\blue0;\\red255\\green255\\blue255;\\red0\\green0\\blue128;\\red0\\green128\\blue128;\\red0\\green128\\blue0;\\red128\\green0\\blue128;\\red128\\green0\\blue0;\\red128\\green128\\blue0;\\red128\\green128\\blue128;\\red192\\green192\\blue192;}{\\stylesheet{\\s0\\snext0\\f37\\fs22\\nowidctlpar\\widctlpar Normal;}{\\s1\\sbasedon0\\snext0\\fs28\\b\\kerning28\\keepn\\sb240\\sa60 Heading 1;}{\\s2\\sbasedon0\\snext0\\fs24\\b\\i\\keepn\\sb240\\sa60 Heading 2;}{\\s3\\sbasedon0\\snext0\\fs22\\b\\keepn\\sb240\\sa60 Heading 3;}}{\\info{\\creatim\\yr2001\\mo8\\dy8\\hr19\\min26\\sec57}{\\author avb}}\\margl1440\\margr1440\\widowctrl";
str+="\\f37\\fs22\\i0\\cf0\\lang1049\\par";
str+="\\f426\\b	\\cf15\\'d2\\'e5\\'ea\\'f1\\'f2\\'ee\\'e2\\'fb\\'e5 \\'f3\\'f2\\'e8\\'eb\\'e8\\'f2\\'fb{\\f426  }V1.4 {\\f426  (AVB }soft\\f426 )\\b0\\cf14\\i\\tab\\i0\\cf1\\par";
str+="\\f422\\cf10 ----------------------------------------------------------------\\f426\\cf1\\par";
str+="\\cf15 Homepage:\\cf1  \\tab\\cf2 http://{\\f385 www.}avbsoft.{\\f385 kulichki}.\\f385 net\\par";
str+="\\par";
str+="\\f426\\cf15 E-mail:\\cf6  \\cf1        \\tab\\f385\\cf2 avbsoft@kulichki.com\\f426   \\cf1     \\par";
str+="\\f422\\cf10 ----------------------------------------------------------------\\cf1\\par";
str+="\\f426\\fs24\\b\\cf15               *      {\\lang1049\\'d0\\'ee\\'f1\\'f1\\'e8\\'ff  } \\'c1\\'e0\\'eb\\'e0\\'ea\\'ee\\'e2\\'ee  2001      *\\cf5\\b0\\i\\par";
str+="\\f37\\fs22\\i0\\cf0\\lang1049\\par";
str+="}";
return str;
}
