// chDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stdafx.h"
#include "chDlg.h"
#include <AVBUtilAcad.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// chDlg dialog


chDlg::chDlg(CWnd* pParent /*=NULL*/)
	: CDialog(chDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(chDlg)
	m_scombo_s = _T("");
	m_sedit_a = _T("");
	m_sedit_h = _T("");
	m_sedit_w = _T("");
	m_scombo_j = _T("");
	m_scombo_r = _T("");
	m_vcheck_block = FALSE;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_AVB);
	//}}AFX_DATA_INIT
}


void chDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(chDlg)
	DDX_Control(pDX, IDC_EDIT_W, m_cedit_w);
	DDX_Control(pDX, IDC_EDIT_H, m_cedit_h);
	DDX_Control(pDX, IDC_EDIT_A, m_cedit_a);
	DDX_Control(pDX, IDC_COMBO_R, m_ccombo_r);
	DDX_Control(pDX, IDC_COMBO_J, m_ccombo_j);
	DDX_Control(pDX, IDC_COMBO_S, m_ccombo_s);
	DDX_CBString(pDX, IDC_COMBO_S, m_scombo_s);
	DDX_Text(pDX, IDC_EDIT_A, m_sedit_a);
	DDX_Text(pDX, IDC_EDIT_H, m_sedit_h);
	DDX_Text(pDX, IDC_EDIT_W, m_sedit_w);
	DDX_CBString(pDX, IDC_COMBO_J, m_scombo_j);
	DDX_CBString(pDX, IDC_COMBO_R, m_scombo_r);
	DDX_Check(pDX, IDC_CHECK_BLOCK, m_vcheck_block);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(chDlg, CDialog)
	//{{AFX_MSG_MAP(chDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// chDlg message handlers

BOOL chDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
	
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	subInitDialog();
	return TRUE;
}

void chDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//  the minimized window.
HCURSOR chDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void chDlg::OnSysCommand(UINT nID, LPARAM lParam)
{

	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		avbAbout dlg;
		dlg.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void chDlg::OnOK() 
{
	/*
	int resType=dxfCodeToDataType(atoi(m_edit_dxf));
	if (resType==RTSTR)
	chRTSTR(ent, atoi(m_edit_dxf) ,(char *)((const char*) m_edit_v));
	else if ((resType == RTREAL))
	chRTREAL(ent, atoi(m_edit_dxf) ,atof(m_edit_v) );
	//chSubReal(ent, atoi(m_edit_dxf) ,atof(m_edit_v) );

	*/
	// TODO: Add extra validation here
CDialog::OnOK();
UpdateData(TRUE);	

ads_name sset; 
AcDbObjectId objId,styleId,attId;
AcDbEntity* pEnt=NULL;
AcDbEntity* psEnt=NULL;
AcGePoint3d pt;
AcDbText* pText;
AcDbText* psText;
AcDbMText* pMText;
AcDbDimension* pDText;
AcDbBlockReference* pBlRef;
long length;

if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ 

acedSSLength(sset, &length);
  for (int i = 0; i < length; i++)
	{
      
	  ads_name ent;
        acedSSName(sset, i, ent);
		acdbGetObjectId(objId, ent);
		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if (pEnt->isKindOf(AcDbText::desc()))
		{
			

			pText = AcDbText::cast(pEnt);
			pText->setHeight(atof(m_sedit_h));
			
			if (m_scombo_s !="")
			{
			styleId=getTextStyleId(m_scombo_s);
			pText->setTextStyle(styleId);
			}
			pText->setWidthFactor(atof(m_sedit_w));
			if (m_sedit_a !="")
			pText->setOblique(PI/180*atof(m_sedit_a));
			if (m_scombo_r != "")
			pText->setRotation(PI/180*atof(m_scombo_r));
		
			if (pText->horizontalMode()==AcDb::kTextLeft)
				pt=pText->position();
			else
				pt=pText->alignmentPoint();
		
				if(m_scombo_j=="" )
				pText->setHorizontalMode(AcDb::kTextLeft);
				else if(m_scombo_j=="" )
				pText->setHorizontalMode(AcDb::kTextRight);
				else if(m_scombo_j=="" )
				pText->setHorizontalMode(AcDb::kTextCenter);

						
			pText->setAlignmentPoint(pt);
			pText->setPosition(pt);
			pEnt->close();
		}
		else if (pEnt->isKindOf(AcDbMText::desc()))
		{
			
			pMText = AcDbMText::cast(pEnt);
			if (m_scombo_r != "")
			pMText->setRotation(PI/180*atof(m_scombo_r));
			pMText->setTextHeight(atof(m_sedit_h));
			
			if (m_scombo_s !="")
			{
			styleId=getTextStyleId(m_scombo_s);
			pMText->setTextStyle(styleId);
			}
				pt=pMText->alignmentPoint();
				if(m_scombo_j=="" )
				pMText->setHorizontalMode(AcDb::kTextLeft);
				else if(m_scombo_j=="" )
				pMText->setHorizontalMode(AcDb::kTextRight);
				else if(m_scombo_j=="" )
				pMText->setHorizontalMode(AcDb::kTextCenter);
				pMText->setAlignmentPoint(pt);
				

			pEnt->close();


		}
		else if (pEnt->isKindOf(AcDbDimension::desc()))
		{
			
			pDText = AcDbDimension::cast(pEnt);
			if (m_scombo_r != "")
			pDText->setTextRotation(PI/180*atof(m_scombo_r));
			pDText->setDimtxt(atof(m_sedit_h));
			
			if (m_scombo_s !="")
			{
			styleId=getTextStyleId(m_scombo_s);
			pDText->setDimtxsty(styleId);
			}
						

			pEnt->close();
		}

		
		else if (pEnt->isKindOf(AcDbBlockReference::desc()))
		{
			pBlRef = AcDbBlockReference::cast(pEnt);

			AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
			
			if (pIterator != NULL) {
			
				while (pIterator->done() == false) 
				{
				attId=pIterator->objectId();
				acdbOpenObject(psEnt, attId, AcDb::kForWrite);
				if (psEnt->isKindOf(AcDbText::desc()))
				{
					psText = AcDbText::cast(psEnt);
					psText->setHeight(atof(m_sedit_h));
					
					if (m_scombo_s !="")
					{
					styleId=getTextStyleId(m_scombo_s);
					psText->setTextStyle(styleId);
					}
					

					psText->setWidthFactor(atof(m_sedit_w));
					if (m_sedit_a !="")
					psText->setOblique(PI/180*atof(m_sedit_a));
					if (m_scombo_r != "")
					psText->setRotation(PI/180*atof(m_scombo_r));
				
					if (psText->horizontalMode()==AcDb::kTextLeft)
						pt=psText->position();
					else
						pt=psText->alignmentPoint();
				
						if(m_scombo_j=="" )
						psText->setHorizontalMode(AcDb::kTextLeft);
						else if(m_scombo_j=="" )
						psText->setHorizontalMode(AcDb::kTextRight);
						else if(m_scombo_j=="" )
						psText->setHorizontalMode(AcDb::kTextCenter);

								
					psText->setAlignmentPoint(pt);
					psText->setPosition(pt);
					psEnt->close();

				}

				pIterator->step();
				}
			delete pIterator;
			pEnt->close();
			if (m_vcheck_block==TRUE)
			{
			struct resbuf *entdata;
			entdata = acdbEntGet(ent); 
			CString blokcName;
			blokcName =getBlockName(entdata);
			chBlock(blokcName);
			acutRelRb(entdata);
			acedCommand(RTSTR, _T("_regen"), 0); 
			}
			}
		}
		else

			pEnt->close();


	}
}

/// 
acedSSFree(sset);


}

void chDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void chDlg::subInitDialog()
{
	addComboStyle();
	addComboJst();
	addComboR();
	m_cedit_a.m_valText="1 2 3 4 5 6 7 8 9 0 . ";
	m_cedit_a.bl=TRUE;
	m_cedit_h.m_valText="1 2 3 4 5 6 7 8 9 0 . ";
	m_cedit_h.bl=TRUE;
	m_cedit_w.m_valText="1 2 3 4 5 6 7 8 9 0 . ";
	m_cedit_w.bl=TRUE;
	

}

void chDlg::addComboStyle()
{
	AcDbTextStyleTable* pStyleTable;
	acdbHostApplicationServices()->workingDatabase()->getTextStyleTable(pStyleTable,
		AcDb::kForRead);
	AcDbTextStyleTableIterator* pIterator;
	pStyleTable->newIterator(pIterator);
	AcDbTextStyleTableRecord *pStyle;
	char * name;
	for( ; !pIterator->done(); pIterator->step())
	{
		pIterator->getRecord(pStyle, AcDb::kForRead);

		pStyle->getName(name);
		
		if(name == NULL)
			continue;
		m_ccombo_s.AddString(name);
		//pStyleTable->getAt(name, styleId);
		pStyle->close();
	}
	delete pIterator;
	pStyleTable->close();
	//m_scombo_s=name;
	//m_ccombo_s.SelectString( -1, m_scombo_s);
	UpdateData(FALSE);
}

void chDlg::addComboJst()
{
m_ccombo_j.AddString("");
m_ccombo_j.AddString("");
m_ccombo_j.AddString("");

}

void chDlg::addComboR()
{
m_ccombo_r.AddString("0");
m_ccombo_r.AddString("90");
}

void chDlg::chBlock(CString blokcName)
{
	UpdateData(TRUE);
	AcDbText* pText;
	AcDbText* psText;
	AcDbMText* pMText;
	AcDbBlockReference* pBlRef;
	AcDbDimension* pDText;
	AcDbObjectId styleId,attId;
	AcDbEntity* psEnt=NULL;
	AcDbEntity *pEnt;

	AcGePoint3d pt;
	AcDbBlockTable *pBlockTable;
	acdbHostApplicationServices()->workingDatabase()
	->getSymbolTable(pBlockTable, AcDb::kForRead);
	AcDbBlockTableRecord *pBlockTableRecord;
	pBlockTable->getAt(blokcName, pBlockTableRecord,AcDb::kForWrite);
	pBlockTable->close();
	AcDbBlockTableRecordIterator *pBlockIterator;
	
	pBlockTableRecord->newIterator(pBlockIterator);

		for (; !pBlockIterator->done();pBlockIterator->step())
		{//1
		
			pBlockIterator->getEntity(pEnt, AcDb::kForWrite);
			AcDbHandle objHandle;
			pEnt->getAcDbHandle(objHandle);
			char handleStr[20];
			objHandle.getIntoAsciiBuffer(handleStr);
			const char *pCname = pEnt->isA()->name();

			CString str;
			str.Format("%s",pCname);
			
				if (str=="AcDbBlockReference")
				{//2
				
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) 
					{//3
					
						while (pIterator->done() == false) 
						{//4
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
							if (psEnt->isKindOf(AcDbText::desc()))
							{//5
								psText = AcDbText::cast(psEnt);
								psText->setHeight(atof(m_sedit_h));
								
								if (m_scombo_s !="")
								{
								styleId=getTextStyleId(m_scombo_s);
								psText->setTextStyle(styleId);
								}
								psText->setWidthFactor(atof(m_sedit_w));
								if (m_sedit_a !="")
								psText->setOblique(PI/180*atof(m_sedit_a));
								if (m_scombo_r != "")
								psText->setRotation(PI/180*atof(m_scombo_r));
							
								if (psText->horizontalMode()==AcDb::kTextLeft)
									pt=psText->position();
								else
									pt=psText->alignmentPoint();
							
									if(m_scombo_j=="" )
									psText->setHorizontalMode(AcDb::kTextLeft);
									else if(m_scombo_j=="" )
									psText->setHorizontalMode(AcDb::kTextRight);
									else if(m_scombo_j=="" )
									psText->setHorizontalMode(AcDb::kTextCenter);

											
								psText->setAlignmentPoint(pt);
								psText->setPosition(pt);
								psEnt->close();

							}//5

						pIterator->step();
						}//4
					delete pIterator;
					}//3
				}//2
				else if ((str=="AcDbText")||(str=="AcDbAttributeDefinition"))
				{//2
					
					pText = AcDbText::cast(pEnt);
					pText->setHeight(atof(m_sedit_h));
					
					if (m_scombo_s !="")
					{
					styleId=getTextStyleId(m_scombo_s);
					pText->setTextStyle(styleId);
					}
					pText->setWidthFactor(atof(m_sedit_w));
					if (m_sedit_a !="")
					pText->setOblique(PI/180*atof(m_sedit_a));
					if (m_scombo_r != "")
					pText->setRotation(PI/180*atof(m_scombo_r));
				
					if (pText->horizontalMode()==AcDb::kTextLeft)
						pt=pText->position();
					else
						pt=pText->alignmentPoint();
				
						if(m_scombo_j=="" )
						pText->setHorizontalMode(AcDb::kTextLeft);
						else if(m_scombo_j=="" )
						pText->setHorizontalMode(AcDb::kTextRight);
						else if(m_scombo_j=="" )
						pText->setHorizontalMode(AcDb::kTextCenter);

								
					pText->setAlignmentPoint(pt);
					pText->setPosition(pt);
				}//2

				else if (str=="AcDbMText")
				{//2
					
					pMText = AcDbMText::cast(pEnt);
					if (m_scombo_r != "")
					pMText->setRotation(PI/180*atof(m_scombo_r));
					pMText->setTextHeight(atof(m_sedit_h));
					
					if (m_scombo_s !="")
					{
					styleId=getTextStyleId(m_scombo_s);
					pMText->setTextStyle(styleId);
					}
						pt=pMText->alignmentPoint();
						if(m_scombo_j=="" )
						pMText->setHorizontalMode(AcDb::kTextLeft);
						else if(m_scombo_j=="" )
						pMText->setHorizontalMode(AcDb::kTextRight);
						else if(m_scombo_j=="" )
						pMText->setHorizontalMode(AcDb::kTextCenter);
						pMText->setAlignmentPoint(pt);
						
				}//2
				else if (pEnt->isKindOf(AcDbDimension::desc()))
				{
					
					pDText = AcDbDimension::cast(pEnt);
					if (m_scombo_r != "")
					pDText->setTextRotation(PI/180*atof(m_scombo_r));
					pDText->setDimtxt(atof(m_sedit_h));
					
					if (m_scombo_s !="")
					{
					styleId=getTextStyleId(m_scombo_s);
					pDText->setDimtxsty(styleId);
					}
					//if (m_sedit_a !="")
					//pDText->setHorizontalRotation(PI/180*atof(m_sedit_a));

					

					
				}


	
				pEnt->close();
		}//1
	
		delete pBlockIterator;
		pBlockTableRecord->close();

				
}
