// replDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stdafx.h"
#include "replDlg.h"
#include <AVBTextUtil.h>
#include <AVBUtilAcad.h>
#include "frDlg.h"
#include "findDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
int selection;
/////////////////////////////////////////////////////////////////////////////
// replDlg dialog


replDlg::replDlg(CWnd* pParent /*=NULL*/)
	: CDialog(replDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(replDlg)
	m_sedit_w = _T("");
	m_sedit_s = _T("");
	m_vcheck_word = FALSE;
	m_vcheck_reg = FALSE;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_AVB);
	m_vcheck_repl = FALSE;
	//}}AFX_DATA_INIT
}


void replDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(replDlg)
	DDX_Control(pDX, IDC_EDIT_SAMPLES, m_cedit_s);
	DDX_Control(pDX, IDC_STATIC_REPL, m_cstatic_repl);
	DDX_Control(pDX, IDC_EDIT_WORD, m_cedit_w);
	DDX_Text(pDX, IDC_EDIT_WORD, m_sedit_w);
	DDX_Text(pDX, IDC_EDIT_SAMPLES, m_sedit_s);
	DDX_Check(pDX, IDC_CHECK_WORD_WHOLLY, m_vcheck_word);
	DDX_Check(pDX, IDC_CHECK_REGISTER, m_vcheck_reg);
	DDX_Check(pDX, IDC_CHECK_FIND, m_vcheck_repl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(replDlg, CDialog)
	//{{AFX_MSG_MAP(replDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK_FIND, OnCheckFind)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// replDlg message handlers

BOOL replDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_cedit_w.EnableWindow(FALSE);
	m_cstatic_repl.EnableWindow(FALSE);
	return TRUE;}

void replDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//  the minimized window.
HCURSOR replDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void replDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		avbAbout dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void replDlg::OnOK() 
{

CDialog::OnOK();
UpdateData(TRUE);
ads_name sset; 
AcDbObjectId objId;
AcDbEntity* pEnt=NULL;
//bool bl=FALSE;
long length;
if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1

acedSSLength(sset, &length);
  for (int i = 0; i < length; i++)
	{//2
      
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);

	  if  (
		  (pEnt->isKindOf(AcDbText::desc()))||
		  (pEnt->isKindOf( AcDbAttributeDefinition::desc()))||
		  (pEnt->isKindOf(AcDbMText::desc()))||
		  (pEnt->isKindOf(AcDbDimension::desc()))
		  )
			{//3
				pEnt->close();
				int res=replace_ent(objId);
				if (res==1)
				{
					//if (bl==TRUE)
					acedCommand(RTSTR, _T("Regen"),0); 
					//unhighlightAll(objId);
					return;
				}
				else if (selection==2)
					//acedCommand(RTSTR, _T("Regen"),0); 
					unhighlightAll(objId);

			}//3
	  else if (pEnt->isKindOf(AcDbBlockReference::desc()))
		  {
			pEnt->close();
			int res=replace_blref(objId);
			//bl=TRUE;
				if (res==1)
				{
					acedCommand(RTSTR, _T("Regen"),0); 
					//unhighlightAll(objId);
					return;
				}
				/*acdbGetAdsName(ent,objId); 
				struct resbuf *entdata;
				entdata = acdbEntGet(ent); 
				int iresbuf=getLength(entdata);
				if (iresbuf==22)
				{
					bl=TRUE;
				acutRelRb(entdata);
				}*/
				else if (selection==2)
					//acedCommand(RTSTR, _T("Regen"),0); 
					unhighlightAll(objId);


		  }
	  else 
		  pEnt->close();

		unhighlightAll(objId);
	 }//2
 }//1
selection=0;
acedSSFree(sset);

//if (bl==TRUE)
//acedCommand(RTSTR, _T("Regen"),0);
}	
		
void replDlg::OnCancel() 
{
	
	CDialog::OnCancel();
}

int replDlg::replace_ent(AcDbObjectId objId)
{//0

UpdateData(TRUE);
AcDbEntity* pEnt=NULL;
AcDbText* pText;
AcDbAttributeDefinition* pAtDef;
AcDbMText* pMText;
AcDbDimension* pDim;

AcGePoint3d pt;
const AcGePoint3d lowerLeft,upperRight;
CAVBTextUtil tu;
CString text,LeftVal,MidVal,NCode,OldCode,LF,RH,regtext,\
regOldCode,keytext,keyOldCode;//1
frDlg dlg(CWnd::FromHandle(adsw_acadMainWnd()));
findDlg dlgFind(CWnd::FromHandle(adsw_acadMainWnd()));
int lenNew,lenText,lenOld,MyPos;
NCode=m_sedit_w;
OldCode=m_sedit_s;
if (m_sedit_s=="")
return 1;
lenNew = NCode.GetLength();
lenOld = OldCode.GetLength();
bool bl=TRUE;
		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if  (pEnt->isKindOf(AcDbText::desc()))
		{
		pText = AcDbText::cast(pEnt);
		if (pEnt->isKindOf( AcDbAttributeDefinition::desc()))
		{
			pAtDef = AcDbAttributeDefinition::cast(pEnt);
			text=pAtDef->tag();
			pt=pAtDef->position();
			pEnt->close();
		}
		else
		{
		text=pText->textString();
		pt=pText->position();
		pEnt->close();
		}
		}
		else if (pEnt->isKindOf(AcDbMText::desc()))
		{
		pMText = AcDbMText::cast(pEnt);
		text=pMText->contents();
		pt=pMText->location();
		pEnt->close();
		}
		else if (pEnt->isKindOf(AcDbDimension::desc()))
		{
		pDim = AcDbDimension::cast(pEnt);
		text=pDim->dimensionText();
		pt=pDim->textPosition();
		pEnt->close();
		}

		CString strL,strR;
		TCHAR xstr[100], ystr[100];

		acdbRToS(pt.x-50, -1, -1, xstr);
		acdbRToS(pt.y+50, -1, -1, ystr);
    
		strL.Format(_T("(%s,%s)"), xstr, ystr);
		strL=tu.replace(strL, "", "(");
		strL=tu.replace(strL, "", ")");

		acdbRToS(pt.x+50, -1, -1, xstr);
		acdbRToS(pt.y-50, -1, -1, ystr);
    
		strR.Format(_T("(%s, %s)"), xstr, ystr);
		strR=tu.replace(strR, "", "(");
		strR=tu.replace(strR, "", ")");

	
	keytext=tu.keyb(text,0);//2
	keyOldCode=tu.keyb(OldCode,0);
	if (m_vcheck_reg==TRUE)
	MyPos =keytext.Find(keyOldCode,0);//3
	else
	{
		regtext=keytext;//4
		regtext.MakeLower();
		regOldCode=keyOldCode;
		regOldCode.MakeLower();	
		MyPos =regtext.Find(regOldCode,0);
	}
if (MyPos==-1)////////////////////////////////////////////
return 0;     //////////////////////////////////////////////
lenText =text.GetLength();
if(m_vcheck_word==TRUE)
{
	if (MyPos==0)
	LF="";
	else
	LF =text.Mid( MyPos-1,1);
	RH=text.Mid(MyPos + lenOld,1);
	if (((LF.IsEmpty())||(LF==" ")) && 
	   ((RH.IsEmpty())||(RH==" ")))
		bl=TRUE;
	else
		bl=FALSE;
}

if (MyPos >=0)
{//1
	highlightAll(objId);	
	acedCommand(RTSTR, _T("Zoom"),RTSTR, "w",RTSTR,
			strL,RTSTR,strR,0); 
	do 
	{//2
   			
			if (m_vcheck_reg==TRUE)
			MyPos =keytext.Find(keyOldCode,MyPos);//5
			else
			{
				regtext=keytext;//6
				regtext.MakeLower();
				regOldCode=keyOldCode;
				regOldCode.MakeLower();	
				MyPos =regtext.Find(regOldCode,MyPos);
				
			
			}

			if (MyPos <0)
				return 0 ;
			if(m_vcheck_word==TRUE)
			{
				if (MyPos==0)
				LeftVal="";
				else
				LF =text.Mid( MyPos-1,1);
				RH=text.Mid(MyPos + lenOld,1);
					if (((LF.IsEmpty())||(LF==" ")) && 
					((RH.IsEmpty())||(RH==" ")))
					bl=TRUE;
					else
					bl=FALSE;
			}
			if ((selection !=3)&&(bl==TRUE)&& (m_vcheck_repl==TRUE))
			{
				dlg.setEdit(text);
				dlg.setSelText(MyPos,lenOld);
				dlg.DoModal();
				
				selection=dlg.getSelection();
			}
			else if ((m_vcheck_repl==FALSE)&&(bl==TRUE))
			{
				dlgFind.setEdit(text);
				dlgFind.setSelText(MyPos,lenOld);
				dlgFind.DoModal();
				selection=dlgFind.getSelection();
			}
		
			if (m_vcheck_repl==TRUE)
			{
			if (selection==4)
			return 1;
			else if (selection==3)
			{//3
				if (bl==TRUE)
				{
				
				lenText = text.GetLength();
				LeftVal =text.Left( MyPos);
				MidVal=text.Mid(MyPos + lenOld);
				text = LeftVal + NCode + MidVal;
				
				keytext=tu.keyb(text,0);
				
				}
			
				acdbOpenObject(pEnt, objId, AcDb::kForWrite);
				if (pEnt->isKindOf(AcDbText::desc()))
				{//4
				pText = AcDbText::cast(pEnt);
					if (pEnt->isKindOf( AcDbAttributeDefinition::desc()))
					{
						pAtDef = AcDbAttributeDefinition::cast(pEnt);
						if (bl==TRUE)
						pAtDef->setTag(text);
						pEnt->close();
						refresh();
					}
					else
					{
						if (bl==TRUE)
						pText->setTextString(text);
						pEnt->close();
						refresh();
					}
				}//4
				
				else if (pEnt->isKindOf(AcDbMText::desc()))
				{
				pMText = AcDbMText::cast(pEnt);
				if (bl==TRUE)
				pMText->setContents(text);
				pEnt->close();
				refresh();
				}//4
				else if (pEnt->isKindOf(AcDbDimension::desc()))
				{
				pDim = AcDbDimension::cast(pEnt);
				if (bl==TRUE)
				pDim->setDimensionText(text);
				pEnt->close();
				refresh();
				}

			MyPos = MyPos + lenNew;
			}//3
			else if (selection==1)
			{//3
				if (bl==TRUE)
				{
				highlightAll(objId);
				lenText = text.GetLength();
				LeftVal =text.Left( MyPos);
				MidVal=text.Mid(MyPos + lenOld);
				text = LeftVal + NCode + MidVal;
			
				keytext=tu.keyb(text,0);
			
				}
				
				acdbOpenObject(pEnt, objId, AcDb::kForWrite);
				if (pEnt->isKindOf(AcDbText::desc()))
				{//4
				
				pText = AcDbText::cast(pEnt);
				if (pEnt->isKindOf( AcDbAttributeDefinition::desc()))
				{
					pAtDef = AcDbAttributeDefinition::cast(pEnt);
					if (bl==TRUE)
					pAtDef->setTag(text);
					pEnt->close();
					refresh();
				}
				else
				{
					if (bl==TRUE)
					pText->setTextString(text);
					pEnt->close();
					refresh();
				}
				}
				else if (pEnt->isKindOf(AcDbMText::desc()))
				{
				pMText = AcDbMText::cast(pEnt);
					if (bl==TRUE)
					pMText->setContents(text);
				pEnt->close();
				refresh();
				}//4
				else if (pEnt->isKindOf(AcDbDimension::desc()))
				{
				pDim = AcDbDimension::cast(pEnt);
				if (bl==TRUE)
				pDim->setDimensionText(text);
				pEnt->close();
				refresh();
				}

			if (bl==TRUE)		
			MyPos = MyPos + lenNew;
			else
			MyPos = MyPos + lenOld;

			}//3
			else 
				MyPos = MyPos + lenOld;
			}
			
			else if(selection==4)
				return 1;
			else 
				MyPos = MyPos + lenOld;
		
	}while (MyPos >= 0);//2

}//1

	unhighlightAll(objId);

return 0;
}

int replDlg::replace_blref(AcDbObjectId objId)
{
UpdateData(TRUE);
AcDbObjectId attId;
AcDbEntity* pEnt=NULL;
AcDbText* psText;
AcDbEntity* psEnt=NULL;
AcDbBlockReference* pBlRef;

		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		
		if (pEnt->isKindOf(AcDbBlockReference::desc()))
				{//1
					pBlRef = AcDbBlockReference::cast(pEnt);

					AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
					
					if (pIterator != NULL) {//2
						while (pIterator->done() == false) 
						{//3
						attId=pIterator->objectId();
						acdbOpenObject(psEnt, attId, AcDb::kForWrite);
						if (psEnt->isKindOf(AcDbText::desc()))
						{//4

							psText = AcDbText::cast(psEnt);
							psEnt->close();
							pEnt->close();
							highlightAll(objId);
							int res=replace_attrib(attId);
							if (res==1)
								return 1;
					
						}//4
						pIterator->step();
						}//3
					delete pIterator;
					pEnt->close();
					refresh();
					}//2

				}//1*/
return 0;
}
int replDlg::replace_attrib(AcDbObjectId objId)
{//0

UpdateData(TRUE);
AcDbEntity* pEnt=NULL;
AcDbText* pText;
AcGePoint3d pt;
CAVBTextUtil tu;
bool bl=TRUE;
CString text,LeftVal,MidVal,NCode,OldCode,LF,RH,regtext,regOldCode,\
keytext,keyOldCode;
frDlg dlg(CWnd::FromHandle(adsw_acadMainWnd()));
findDlg dlgFind(CWnd::FromHandle(adsw_acadMainWnd()));
int lenNew,lenText,lenOld,MyPos;
NCode=m_sedit_w;
OldCode=m_sedit_s;
if (m_sedit_s=="")
return 1;
lenNew = NCode.GetLength();
lenOld = OldCode.GetLength();

acdbOpenObject(pEnt, objId, AcDb::kForWrite);

		if  (pEnt->isKindOf(AcDbText::desc()))
		{//1
			pText = AcDbText::cast(pEnt);
			text=pText->textString();
			if(m_vcheck_word==TRUE)
				text=" "+text+" ";

			pt=pText->position();
			pEnt->close();
		}//1
			CString strL,strR;
			TCHAR xstr[100], ystr[100];

			acdbRToS(pt.x-50, -1, -1, xstr);
			acdbRToS(pt.y+50, -1, -1, ystr);
    
			strL.Format(_T("(%s,%s)"), xstr, ystr);
			strL=tu.replace(strL, "", "(");
			strL=tu.replace(strL, "", ")");

			acdbRToS(pt.x+50, -1, -1, xstr);
			acdbRToS(pt.y-50, -1, -1, ystr);
    
			strR.Format(_T("(%s, %s)"), xstr, ystr);
			strR=tu.replace(strR, "", "(");
			strR=tu.replace(strR, "", ")");
	keytext=tu.keyb(text,0);//2
	keyOldCode=tu.keyb(OldCode,0);
	if (m_vcheck_reg==TRUE)
	MyPos =keytext.Find(keyOldCode,0);//3
	else
	{
		regtext=keytext;//4
		regtext.MakeLower();
		regOldCode=keyOldCode;
		regOldCode.MakeLower();	
		MyPos =regtext.Find(regOldCode,0);
	}

lenText =text.GetLength();
//MyPos =keytext.Find(keyOldCode,0);
if (MyPos==-1)////////////////////////////////////////////
return 0;     //////////////////////////////////////////////

if(m_vcheck_word==TRUE)
{
	if (MyPos==0)
	LF="";
	else
	LF =text.Mid( MyPos-1,1);
	RH=text.Mid(MyPos + lenOld,1);
	if (((LF.IsEmpty())||(LF==" ")) && 
	   ((RH.IsEmpty())||(RH==" ")))
		bl=TRUE;
	else
		bl=FALSE;
}
if (MyPos >=0)
{//1
	
	acedCommand(RTSTR, _T("Zoom"),RTSTR, "w",RTSTR,
			strL,RTSTR,strR,0); 

	do 
	{//2
   			
			if (m_vcheck_reg==TRUE)
			MyPos =keytext.Find(keyOldCode,MyPos);//5
			else
			{
				regtext=keytext;
				regtext.MakeLower();
				regOldCode=keyOldCode;
				regOldCode.MakeLower();	
				MyPos =regtext.Find(regOldCode,MyPos);
			}

			if (MyPos <0)
				return 0 ;
			if(m_vcheck_word==TRUE)
			{
				if (MyPos==0)
				LeftVal="";
				else
				LF =text.Mid( MyPos-1,1);
				RH=text.Mid(MyPos + lenOld,1);
					if (((LF.IsEmpty())||(LF==" ")) && 
					((RH.IsEmpty())||(RH==" ")))
					bl=TRUE;
					else
					bl=FALSE;
			}
			if ((selection !=3)&&(bl==TRUE)&& (m_vcheck_repl==TRUE))
			{
				dlg.setEdit(text);
				dlg.setSelText(MyPos,lenOld);
				dlg.DoModal();
				selection=dlg.getSelection();
			}
			else if ((m_vcheck_repl==FALSE)&&(bl==TRUE))
			{
				dlgFind.setEdit(text);
				dlgFind.setSelText(MyPos,lenOld);
				dlgFind.DoModal();
				selection=dlgFind.getSelection();
			}
		
			if (m_vcheck_repl==TRUE)
			{
			
			if (selection==4)
			return 1;
			else if (selection==3)
			{//3
				if (bl==TRUE)
				{

					lenText = text.GetLength();
					LeftVal =text.Left( MyPos);
					MidVal=text.Mid(MyPos + lenOld);
					text = LeftVal + NCode + MidVal;
					keytext=tu.keyb(text,0);
				}
				acdbOpenObject(pEnt, objId, AcDb::kForWrite);
				if (pEnt->isKindOf(AcDbText::desc()))
				{//4
				
				pText = AcDbText::cast(pEnt);
					if (bl==TRUE)
					pText->setTextString(text);
				pEnt->close();
				//refresh();
				}//4
				MyPos = MyPos + lenNew;
			}//3
			else if (selection==1)
			{//3
				if (bl==TRUE)
				{
					lenText = text.GetLength();
					LeftVal =text.Left( MyPos);
					MidVal=text.Mid(MyPos + lenOld);
					text = LeftVal + NCode + MidVal;
					keytext=tu.keyb(text,0);
				}
				acdbOpenObject(pEnt, objId, AcDb::kForWrite);
				if (pEnt->isKindOf(AcDbText::desc()))
				{//4
				pText = AcDbText::cast(pEnt);
					if (bl==TRUE)
					pText->setTextString(text);
				pEnt->close();
				refresh();
				}//4
					if (bl==TRUE)		
					MyPos = MyPos + lenNew;
					else
					MyPos = MyPos + lenOld;
			
			}//3
			else 
				MyPos = MyPos + lenOld;
			}
			
			else if(selection==4)
				return 1;
			else 
				MyPos = MyPos + lenOld;
	}while (MyPos >= 0);//2
}//1

return 0;
}//0


void replDlg::OnCheckFind() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if (m_vcheck_repl==TRUE)
	{
		m_cedit_w.EnableWindow(TRUE);
		m_cstatic_repl.EnableWindow(TRUE);
		m_repl=1;

	}
	else
	{
		m_cedit_w.EnableWindow(FALSE);
		m_cstatic_repl.EnableWindow(FALSE);
		m_repl=2;
	}
	
}

void replDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
m_cedit_s.SetFocus();	
}

int replDlg::getRepl()
{
return m_repl;
}
