// dwDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stdafx.h"
#include "dwDlg.h"
#include <AVBUtilAcad.h>
#include <AVBTextUtil.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// dwDlg dialog


dwDlg::dwDlg(CWnd* pParent /*=NULL*/)
	: CDialog(dwDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(dwDlg)
	m_scombo_n = _T("");
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_AVB);
	m_sstatic_f = _T("");
	//}}AFX_DATA_INIT
}


void dwDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(dwDlg)
	DDX_Control(pDX, IDC_COMBO_NEW, m_ccombo_n);
	DDX_CBString(pDX, IDC_COMBO_NEW, m_scombo_n);
	DDX_Text(pDX, IDC_STATIC_FONT, m_sstatic_f);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(dwDlg, CDialog)
	//{{AFX_MSG_MAP(dwDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELENDOK(IDC_COMBO_NEW, OnSelendokComboNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// dwDlg message handlers

BOOL dwDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	subInitDialog();
	return TRUE;
}

void dwDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//  the minimized window.
HCURSOR dwDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void dwDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		avbAbout dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void dwDlg::OnOK() 
{
	// TODO: Add extra validation here
CDialog::OnOK();
UpdateData(TRUE);
ads_name sset; 
AcDbObjectId objId,styleId,attId;
AcDbEntity* pEnt=NULL;
AcDbEntity* psEnt=NULL;
AcGePoint3d pt;
AcDbText* pText;
AcDbText* psText;
AcDbAttributeDefinition* pAtDef;
AcDbMText* pMText;
AcDbBlockReference* pBlRef;
AcDbDimension* pDText;
CAVBTextUtil tu;
long length;
if(acedSSGet(NULL, NULL, NULL, NULL, sset)==RTNORM)
{ //1

acedSSLength(sset, &length);
  for (int i = 0; i < length; i++)
	{//2
 
	  ads_name ent;
      acedSSName(sset, i, ent);
      acdbGetObjectId(objId, ent);
	  struct resbuf* entdata;
	  entdata = acdbEntGet(ent); 
	  int lenRB= getLength(entdata);
	  CString objectName =(CString)getObjectName(entdata);
	  acutRelRb(entdata);
	  
	  acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		int result=100;
		if (int result=strcmp(objectName,"TEXT")==0)
		{//3
			
			pText = AcDbText::cast(pEnt);
			
			styleId=pText->textStyle(); 
			
				if (m_scombo_n !="")
				{
					styleId=getTextStyleId(m_scombo_n);
					pText->setTextStyle(styleId);
				}
						
			pText->setTextString(tu.dw(pText->textString()));
		
			pEnt->close();
		}
		else if (int result=strcmp(objectName,"ATTDEF")==0)
		{
			
			pAtDef=AcDbAttributeDefinition::cast(pEnt) ;

				styleId=pAtDef->textStyle(); 
			
				if (m_scombo_n !="")
				{
					styleId=getTextStyleId(m_scombo_n);
					pAtDef->setTextStyle(styleId);
				}
			// ATTDEF  TEXT
			CString tag =pAtDef->tag();
			AcDbObjectId idObj;
			double height = pAtDef->height();
			double rotation = pAtDef->rotation();
			AcDbText *pnText = new AcDbText(pAtDef->position() ,tag,styleId,height,rotation);
			pnText->setWidthFactor(pAtDef->widthFactor());
			pnText->setOblique(pAtDef->oblique());
			pnText->setHorizontalMode(pAtDef->horizontalMode());
			pnText->setAlignmentPoint(pAtDef->alignmentPoint());
			pnText->setPosition(pAtDef->position());
			//pnText->setTextStyle(styleId);
			postToDatabase(pnText, idObj);
			pEnt->erase();
			pEnt->close();
			pnText->close();
			
			
		}//3
		else if (pEnt->isKindOf(AcDbMText::desc()))
		{//3
			
			pMText = AcDbMText::cast(pEnt);
			if (m_scombo_n !="")
			{
			styleId=getTextStyleId(m_scombo_n);
			pMText->setTextStyle(styleId);
			}

			pEnt->close();
			
			CString s;
			s =getRTSTR(ent, 1);
			s=tu.dw(s);
			chRTSTR(ent, 1 ,(char *)((const char*)s));
			
		

		}//3
		else if (pEnt->isKindOf(AcDbDimension ::desc()))
		{//3
			pDText = AcDbDimension::cast(pEnt);
			if (m_scombo_n != "")
			{
			styleId=getTextStyleId(m_scombo_n);
			pDText->setDimtxsty(styleId);
			}

			pEnt->close();
			CString s;
			s =getRTSTR(ent, 1);
			s=tu.dw(s);
			chRTSTR(ent, 1 ,(char *)((const char*)s));
		}//3

		else if (pEnt->isKindOf(AcDbBlockReference::desc()))
		{//3
			
			pBlRef = AcDbBlockReference::cast(pEnt);

			AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
			
			if (pIterator != NULL) {//4
			
				while (pIterator->done() == false) 
				{//5
				attId=pIterator->objectId();
				acdbOpenObject(psEnt, attId, AcDb::kForWrite);
				if (psEnt->isKindOf(AcDbText::desc()))
				{//6
					
					psText = AcDbText::cast(psEnt);
					styleId=psText->textStyle(); 
					
						psText->setTextString(tu.dw(psText->textString()));
						if (m_scombo_n !="")
						{
							styleId=getTextStyleId(m_scombo_n);
							psText->setTextStyle(styleId);
						}
					
					psEnt->close();
				}//6
				pIterator->step();
				}//5
			delete pIterator;
			pEnt->close();
			
			struct resbuf *entdata;
			entdata = acdbEntGet(ent); 
			CString blokcName;
			blokcName =getBlockName(entdata);
			chBlock(blokcName);
			acutRelRb(entdata);
			
			
			
			}//4
		}//3
		else

			pEnt->close();


	
	}//2

/// 
acedSSFree(sset);
acedCommand(RTSTR, _T("_regen"), 0); 
}//1

}
void dwDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void dwDlg::subInitDialog()
{
	addComboStyle();
	
}

void dwDlg::addComboStyle()
{
	AcDbTextStyleTable* pStyleTable;
	acdbHostApplicationServices()->workingDatabase()->getTextStyleTable(pStyleTable,
		AcDb::kForRead);
	AcDbTextStyleTableIterator* pIterator;
	pStyleTable->newIterator(pIterator);
	AcDbTextStyleTableRecord *pStyle;
	char * name;
	for( ; !pIterator->done(); pIterator->step())
	{
		pIterator->getRecord(pStyle, AcDb::kForRead);

		pStyle->getName(name);
		
		if(name == NULL)
			continue;
		m_ccombo_n.AddString(name);
		m_ccombo_o.AddString(name);
		//pStyleTable->getAt(name, styleId);
		pStyle->close();
	}
	delete pIterator;
	pStyleTable->close();
	/*m_scombo_o=name;
	m_ccombo_o.SelectString( -1, m_scombo_o);
	m_scombo_n=name;
	m_ccombo_n.SelectString( -1, m_scombo_n);*/

	UpdateData(FALSE);
}

void dwDlg::OnRadioDw() 
{
	// TODO: Add your control notification handler code here
	check_dw=FALSE;
}

void dwDlg::OnRadioWd() 
{
check_dw=TRUE;	
}

void dwDlg::OnSelendokComboNew() 
{
	int nSelected = m_ccombo_n.GetCurSel() ;
	AcDbObjectId styleId;
	CString cs;
	if ( nSelected >= 0 )
		{
		
		m_ccombo_n.GetLBText ( nSelected, cs) ;
		styleId=getTextStyleId(cs);
		
		CString styleFont;
		getTextStyleFont(styleFont, styleId);
		m_sstatic_f =styleFont;
		
		}
	
	UpdateData(FALSE);		
}

void dwDlg::chBlock(CString blokcName)
{
	UpdateData(TRUE);
	AcDbText* pText;
	AcDbMText* pMText;
	AcDbText* psText;
//	AcDbDimension* pDText;
	
	AcDbBlockReference* pBlRef;
	AcDbObjectId styleId,attId,entId;
	AcDbEntity* psEnt=NULL;
	AcDbEntity *pEnt;
	CAVBTextUtil tu;
	ads_name ent;
	AcGePoint3d pt;
	AcDbBlockTable *pBlockTable;
	acdbHostApplicationServices()->workingDatabase()
	->getSymbolTable(pBlockTable, AcDb::kForRead);
	AcDbBlockTableRecord *pBlockTableRecord;
	pBlockTable->getAt(blokcName, pBlockTableRecord,AcDb::kForWrite);
	pBlockTable->close();
	AcDbBlockTableRecordIterator *pBlockIterator;
	
	pBlockTableRecord->newIterator(pBlockIterator);

		for (; !pBlockIterator->done();pBlockIterator->step())
		{//1
		
			pBlockIterator->getEntity(pEnt, AcDb::kForWrite);
			AcDbHandle objHandle;
			pEnt->getAcDbHandle(objHandle);
			char handleStr[20];
			objHandle.getIntoAsciiBuffer(handleStr);
			const char *pCname = pEnt->isA()->name();
			CString str;
			str.Format("%s",pCname);
			
			if (str=="AcDbBlockReference")
			{//2
				
			pBlRef = AcDbBlockReference::cast(pEnt);

			AcDbObjectIterator* pIterator=pBlRef->attributeIterator();
			
			if (pIterator != NULL) {//3
			
				while (pIterator->done() == false) 
				{//4
				attId=pIterator->objectId();
				acdbOpenObject(psEnt, attId, AcDb::kForWrite);
				if (psEnt->isKindOf(AcDbText::desc()))
				{//5
					
					psText = AcDbText::cast(psEnt);
					styleId=psText->textStyle(); 
					
						psText->setTextString(tu.dw(psText->textString()));
						if (m_scombo_n !="")
						{
							styleId=getTextStyleId(m_scombo_n);
							psText->setTextStyle(styleId);
						}
					
					psEnt->close();
				}//5
				pIterator->step();
				}//4
				delete pIterator;
			
			}//3
			
			}//2
			else if ((str=="AcDbText")||(str=="AcDbAttributeDefinition"))
			{//2
				
				pText = AcDbText::cast(pEnt);
				styleId=pText->textStyle(); 
			
				pText->setTextString(tu.dw(pText->textString()));
				if (m_scombo_n !="")
				{
					styleId=getTextStyleId(m_scombo_n);
					pText->setTextStyle(styleId);
				}
			
			pEnt->close();
			}//2
			/*else if (pEnt->isKindOf(AcDbDimension ::desc()))
			{//2
			
			pDText = AcDbDimension::cast(pEnt);
			if (m_scombo_n != "")
			{
			styleId=getTextStyleId(m_scombo_n);
			pDText->setDimtxsty(styleId);
			}

			pEnt->close();
			CString s;
			//s =getRTSTR(ent, 1);
			s=getSubRTSTR(ent, 1 );
			s=tu.dw(s);
			//MessageBox(s);
			//chRTSTR(ent, 1 ,(char *)((const char*)s));
			chSubRTSTR(ent, 1 ,(char *)((const char *)s) );
				
			
			}//2*/

			else if (pEnt->isKindOf(AcDbMText::desc()))
			{//2
				pMText = AcDbMText::cast(pEnt);
				if (m_scombo_n !="")
				{
				styleId=getTextStyleId(m_scombo_n);
				pMText->setTextStyle(styleId);
				}
				
				pBlockIterator->getEntityId(entId);
				acdbGetAdsName(ent, entId); 
				pEnt->close();
				
				CString s;
				s =getRTSTR(ent, 1);
				s=tu.dw(s);
				chRTSTR(ent, 1 ,(char *)((const char*)s));
				
			}//2
			pEnt->close();
					
		}//1
	
		delete pBlockIterator;
		pBlockTableRecord->close();
}
