// frDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stdafx.h"
#include "frDlg.h"
#include "replDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// frDlg dialog


frDlg::frDlg(CWnd* pParent /*=NULL*/)
	: CAcUiDialog(frDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(frDlg)
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_AVB);
	m_sedit = _T("");
	//}}AFX_DATA_INIT
}
frDlg::~frDlg()
{

}

void frDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(frDlg)

	DDX_Control(pDX, IDC_EDIT, m_cedit);
	DDX_Text(pDX, IDC_EDIT, m_sedit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(frDlg, CDialog)
	//{{AFX_MSG_MAP(frDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDREPL, OnRepl)
	ON_BN_CLICKED(IDMISS, OnMiss)
	ON_BN_CLICKED(IDAUTOMATICALLY, OnAutomatically)
	ON_WM_SHOWWINDOW()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// frDlg message handlers

BOOL frDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	UpdateData(FALSE);
/*	m_cedit.m_valText="";
	m_cedit.bl=FALSE;
	m_cedit.m_clrText=RGB(0,0,0);
	m_cedit.m_clrBkgnd=RGB(192,192,192);
	m_cedit.m_brBkgnd.CreateSolidBrush(m_cedit.m_clrBkgnd);*/
	
	m_cedit.SetSel(m_start,m_start+m_length);
	replDlg dlg(CWnd::FromHandle(adsw_acadMainWnd()));
	return TRUE;
}

void frDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//  the minimized window.
HCURSOR frDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void frDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		avbAbout dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void frDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_selection=4;
	CDialog::OnCancel();
}

CString frDlg::setEdit(CString text)
{
m_sedit=text;
return m_sedit;
}

void frDlg::OnRepl() 
{

	m_selection=1;	
	CDialog::OnOK(); 
	//refresh();
}

void frDlg::OnMiss() 
{
m_selection=2;
CDialog::OnOK(); 	
}

void frDlg::OnAutomatically() 
{

	/*BeginEditorCommand();
	ShowWindow(SW_HIDE);*/
	m_selection=3;
	CDialog::OnCancel(); 
	/*CompleteEditorCommand();
	ShowWindow(SW_SHOW);
	return;*/

	
}

int frDlg::getSelection()
{
return m_selection;
}

void frDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
m_cedit.SetFocus();
	
}

void frDlg::setSelText(int start, int length)
{
m_start=start;
m_length=length;
}



void frDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	acedCommand(RTSTR, _T("_regen"), 0); 
	CDialog::OnClose();
}
